# GstH264Parser

It offers bitstream parsing in both AVC (length-prefixed) and Annex B (0x000001 start code prefix) format. To identify a NAL unit in a bitstream and parse its headers, first call:

- gst_h264_parser_identify_nalu to identify a NAL unit in an Annex B type bitstream

- gst_h264_parser_identify_nalu_avc to identify a NAL unit in an AVC type bitstream

The following functions are then available for parsing the structure of the GstH264NalUnit, depending on the GstH264NalUnitType:

- From GST_H264_NAL_SLICE to GST_H264_NAL_SLICE_IDR: gst_h264_parser_parse_slice_hdr

- GST_H264_NAL_SEI: gst_h264_parser_parse_sei

- GST_H264_NAL_SPS: gst_h264_parser_parse_sps

- GST_H264_NAL_PPS: gst_h264_parser_parse_pps

- Any other: gst_h264_parser_parse_nal

One of these functions must be called on every NAL unit in the bitstream, in order to keep the internal structures of the GstH264NalParser up to date. It is legal to call gst_h264_parser_parse_nal on NAL units of any type, if no special parsing of the current NAL unit is required by the application.

For more details about the structures, look at the ITU-T H.264 and ISO/IEC 14496-10 â€“ MPEG-4 Part 10 specifications, available at:

- ITU-T H.264: http://www.itu.int/rec/T-REC-H.264

- ISO/IEC 14496-10: http://www.iso.org/iso/iso_catalogue/catalogue_tc/catalogue_detail.htm?csnumber=56538

## Functions

### gst_h264_create_sei_memory

    GstMemory *
    gst_h264_create_sei_memory (guint8 start_code_prefix_length,
                                GArray * messages)

Creates raw byte-stream format (a.k.a Annex B type) SEI nal unit data from messages

Parameters:

`start_code_prefix_length` –

a length of start code prefix, must be 3 or 4

`messages` –

a GArray of GstH264SEIMessage

Returns (GstMemory *) –

a GstMemory containing a SEI nal unit

Since : 1.18

### gst_h264_create_sei_memory_avc

    GstMemory *
    gst_h264_create_sei_memory_avc (guint8 nal_length_size,
                                    GArray * messages)

Creates raw packetized format SEI nal unit data from messages

Parameters:

`nal_length_size` –

a size of nal length field, allowed range is [1, 4]

`messages` –

a GArray of GstH264SEIMessage

Returns (GstMemory *) –

a GstMemory containing a SEI nal unit

Since : 1.18

### gst_h264_decoder_config_record_free

    void
    gst_h264_decoder_config_record_free (GstH264DecoderConfigRecord * config)

Free config data

Parameters:

`config` –

a GstH264DecoderConfigRecord data

Returns (void ) –
No description available

Since : 1.22

### gst_h264_nal_parser_free

    void
    gst_h264_nal_parser_free (GstH264NalParser * nalparser)

Frees nalparser

Parameters:

`nalparser` –

the GstH264NalParser to free

Returns (void ) –
No description available

### gst_h264_nal_parser_new

    GstH264NalParser *
    gst_h264_nal_parser_new ()

Creates a new GstH264NalParser. It should be freed with gst_h264_nal_parser_free after use.

Returns (GstH264NalParser *) –

a new GstH264NalParser

### gst_h264_parse_pps

    GstH264ParserResult
    gst_h264_parse_pps (GstH264NalParser * nalparser,
                        GstH264NalUnit * nalu,
                        GstH264PPS * pps)

Parses data, and fills the pps structure.

The resulting pps data structure shall be deallocated with the gst_h264_pps_clear function when it is no longer needed, or prior to parsing a new PPS NAL unit.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GST_H264_NAL_PPS GstH264NalUnit to parse

`pps` –

The GstH264PPS to fill.

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parse_sps

    GstH264ParserResult
    gst_h264_parse_sps (GstH264NalUnit * nalu,
                        GstH264SPS * sps)

Parses data, and fills the sps structure.

Parameters:

`nalu` –

The GST_H264_NAL_SPS GstH264NalUnit to parse

`sps` –

The GstH264SPS to fill.

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parse_subset_sps

    GstH264ParserResult
    gst_h264_parse_subset_sps (GstH264NalUnit * nalu,
                               GstH264SPS * sps)

Parses data, and fills in the sps structure.

This function fully parses data and allocates all the necessary data structures needed for MVC extensions. The resulting sps structure shall be deallocated with gst_h264_sps_clear when it is no longer needed.

Note: if the caller doesn't need any of the MVC-specific data, then gst_h264_parser_parse_sps is more efficient because those extra syntax elements are not parsed and no extra memory is allocated.

Parameters:

`nalu` –

The GST_H264_NAL_SUBSET_SPS GstH264NalUnit to parse

`sps` –

The GstH264SPS to fill.

Returns (GstH264ParserResult) –

a GstH264ParserResult

Since : 1.6

### gst_h264_parser_identify_and_split_nalu_avc

    GstH264ParserResult
    gst_h264_parser_identify_and_split_nalu_avc (GstH264NalParser * nalparser,
                                                 guint8 * data,
                                                 guint offset,
                                                 gsize size,
                                                 guint8 nal_length_size,
                                                 GArray * nalus,
                                                 gsize * consumed)

Parses data for packetized (e.g., avc/avc3) bitstream and sets nalus. In addition to nal identifying process, this method scans start-code prefix to split malformed packet into actual nal chunks.

Parameters:

`nalparser` –

a GstH264NalParser

`data` –

The data to parse, containing an AVC coded NAL unit

`offset` –

the offset in data from which to parse the NAL unit

`size` –

the size of data

`nal_length_size` –

the size in bytes of the AVC nal length prefix.

`nalus` –

a caller allocated GArray of GstH264NalUnit where to store parsed nal headers

`consumed` –

the size of consumed bytes

Returns (GstH264ParserResult) –

a GstH264ParserResult

Since : 1.22.9

### gst_h264_parser_identify_nalu

    GstH264ParserResult
    gst_h264_parser_identify_nalu (GstH264NalParser * nalparser,
                                   guint8 * data,
                                   guint offset,
                                   gsize size,
                                   GstH264NalUnit * nalu)

Parses the headers of an Annex B coded NAL unit from data and puts the result into nalu.

Parameters:

`nalparser` –

a GstH264NalParser

`data` –

The data to parse, containing an Annex B coded NAL unit

`offset` –

the offset in data from which to parse the NAL unit

`size` –

the size of data

`nalu` –

The GstH264NalUnit to store the identified NAL unit in

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_identify_nalu_avc

    GstH264ParserResult
    gst_h264_parser_identify_nalu_avc (GstH264NalParser * nalparser,
                                       guint8 * data,
                                       guint offset,
                                       gsize size,
                                       guint8 nal_length_size,
                                       GstH264NalUnit * nalu)

Parses the headers of an AVC coded NAL unit from data and puts the result into nalu.

Parameters:

`nalparser` –

a GstH264NalParser

`data` –

The data to parse, containing an AVC coded NAL unit

`offset` –

the offset in data from which to parse the NAL unit

`size` –

the size of data

`nal_length_size` –

the size in bytes of the AVC nal length prefix.

`nalu` –

The GstH264NalUnit to store the identified NAL unit in

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_identify_nalu_unchecked

    GstH264ParserResult
    gst_h264_parser_identify_nalu_unchecked (GstH264NalParser * nalparser,
                                             guint8 * data,
                                             guint offset,
                                             gsize size,
                                             GstH264NalUnit * nalu)

Parses data and fills nalu from the next nalu data from data.

This differs from gst_h264_parser_identify_nalu in that it doesn't check whether the packet is complete or not.

Note: Only use this function if you already know the provided data is a complete NALU, else use gst_h264_parser_identify_nalu.

Parameters:

`nalparser` –

a GstH264NalParser

`data` –

The data to parse

`offset` –

the offset from which to parse data

`size` –

the size of data

`nalu` –

The GstH264NalUnit where to store parsed nal headers

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_insert_sei

    GstBuffer *
    gst_h264_parser_insert_sei (GstH264NalParser * nalparser,
                                GstBuffer * au,
                                GstMemory * sei)

Copy au into new GstBuffer and insert sei into the GstBuffer. The validation for completeness of au and sei is caller's responsibility. Both au and sei must be byte-stream formatted

Parameters:

`nalparser` –

a GstH264NalParser

`au` –

a GstBuffer containing AU data

`sei` –

a GstMemory containing a SEI nal

Returns (GstBuffer *) –

a SEI inserted GstBuffer or NULL if cannot figure out proper position to insert a sei

Since : 1.18

### gst_h264_parser_insert_sei_avc

    GstBuffer *
    gst_h264_parser_insert_sei_avc (GstH264NalParser * nalparser,
                                    guint8 nal_length_size,
                                    GstBuffer * au,
                                    GstMemory * sei)

Copy au into new GstBuffer and insert sei into the GstBuffer. The validation for completeness of au and sei is caller's responsibility. Nal prefix type of both au and sei must be packetized, and also the size of nal length field must be identical to nal_length_size

Parameters:

`nalparser` –

a GstH264NalParser

`nal_length_size` –

a size of nal length field, allowed range is [1, 4]

`au` –

a GstBuffer containing AU data

`sei` –

a GstMemory containing a SEI nal

Returns (GstBuffer *) –

a SEI inserted GstBuffer or NULL if cannot figure out proper position to insert a sei

Since : 1.18

### gst_h264_parser_parse_decoder_config_record

    GstH264ParserResult
    gst_h264_parser_parse_decoder_config_record (GstH264NalParser * nalparser,
                                                 guint8 * data,
                                                 gsize size,
                                                 GstH264DecoderConfigRecord ** config)

Parses AVCDecoderConfigurationRecord data and fill into config. The caller must free config via gst_h264_decoder_config_record_free

This method does not parse SPS and PPS and therefore the caller needs to parse each NAL unit via appropriate parsing method.

Parameters:

`nalparser` –

a GstH264NalParser

`data` –

the data to parse

`size` –

the size of data

`config` –

parsed GstH264DecoderConfigRecord data

Returns (GstH264ParserResult) –

a GstH264ParserResult

Since : 1.22

### gst_h264_parser_parse_nal

    GstH264ParserResult
    gst_h264_parser_parse_nal (GstH264NalParser * nalparser,
                               GstH264NalUnit * nalu)

This function should be called in the case one doesn't need to parse a specific structure. It is necessary to do so to make sure nalparser is up to date.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GstH264NalUnit to parse

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_parse_pps

    GstH264ParserResult
    gst_h264_parser_parse_pps (GstH264NalParser * nalparser,
                               GstH264NalUnit * nalu,
                               GstH264PPS * pps)

Parses nalu containing a Picture Parameter Set, and fills pps.

The resulting pps data structure must be deallocated by the caller using gst_h264_pps_clear.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GST_H264_NAL_PPS GstH264NalUnit to parse

`pps` –

The GstH264PPS to fill.

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_parse_sei

    GstH264ParserResult
    gst_h264_parser_parse_sei (GstH264NalParser * nalparser,
                               GstH264NalUnit * nalu,
                               GArray ** messages)

Parses nalu containing one or more Supplementary Enhancement Information messages, and allocates and fills the messages array.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GST_H264_NAL_SEI GstH264NalUnit to parse

`messages` –

The GArray of GstH264SEIMessage to fill. The caller must free it when done.

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_parse_slice_hdr

    GstH264ParserResult
    gst_h264_parser_parse_slice_hdr (GstH264NalParser * nalparser,
                                     GstH264NalUnit * nalu,
                                     GstH264SliceHdr * slice,
                                     gboolean parse_pred_weight_table,
                                     gboolean parse_dec_ref_pic_marking)

Parses nalu containing a coded slice, and fills slice.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GST_H264_NAL_SLICE to GST_H264_NAL_SLICE_IDR GstH264NalUnit to parse

`slice` –

The GstH264SliceHdr to fill.

`parse_pred_weight_table` –

Whether to parse the pred_weight_table or not

`parse_dec_ref_pic_marking` –

Whether to parse the dec_ref_pic_marking or not

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_parse_sps

    GstH264ParserResult
    gst_h264_parser_parse_sps (GstH264NalParser * nalparser,
                               GstH264NalUnit * nalu,
                               GstH264SPS * sps)

Parses nalu containing a Sequence Parameter Set, and fills sps.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GST_H264_NAL_SPS GstH264NalUnit to parse

`sps` –

The GstH264SPS to fill.

Returns (GstH264ParserResult) –

a GstH264ParserResult

### gst_h264_parser_parse_subset_sps

    GstH264ParserResult
    gst_h264_parser_parse_subset_sps (GstH264NalParser * nalparser,
                                      GstH264NalUnit * nalu,
                                      GstH264SPS * sps)

Parses data, and fills in the sps structure.

This function fully parses data and allocates all the necessary data structures needed for MVC extensions. The resulting sps structure shall be deallocated with gst_h264_sps_clear when it is no longer needed.

Note: if the caller doesn't need any of the MVC-specific data, then gst_h264_parser_parse_sps is more efficient because those extra syntax elements are not parsed and no extra memory is allocated.

Parameters:

`nalparser` –

a GstH264NalParser

`nalu` –

The GST_H264_NAL_SUBSET_SPS GstH264NalUnit to parse

`sps` –

The GstH264SPS to fill.

Returns (GstH264ParserResult) –

a GstH264ParserResult

Since : 1.6

### gst_h264_parser_update_pps

    GstH264ParserResult
    gst_h264_parser_update_pps (GstH264NalParser * nalparser,
                                GstH264PPS * pps)

Replace internal Picture Parameter Set struct corresponding to id of pps with pps. nalparser will mark pps as last parsed pps.

Parameters:

`nalparser` –

a GstH264NalParser

`pps` –

a GstH264PPS.

Returns (GstH264ParserResult) –

a GstH264ParserResult

Since : 1.18

### gst_h264_parser_update_sps

    GstH264ParserResult
    gst_h264_parser_update_sps (GstH264NalParser * nalparser,
                                GstH264SPS * sps)

Replace internal Sequence Parameter Set struct corresponding to id of sps with sps. nalparser will mark sps as last parsed sps.

Parameters:

`nalparser` –

a GstH264NalParser

`sps` –

a GstH264SPS.

Returns (GstH264ParserResult) –

a GstH264ParserResult

Since : 1.18

### gst_h264_pps_clear

    void
    gst_h264_pps_clear (GstH264PPS * pps)

Clears all pps internal resources.

Parameters:

`pps` –

The GstH264PPS to free

Returns (void ) –
No description available

Since : 1.4

### gst_h264_profile_from_string

    GstH264Profile
    gst_h264_profile_from_string (gchar * profile)

Returns a GstH264Profile for the string.

Parameters:

`profile` –
No description available
Returns (GstH264Profile) –

the GstH264Profile of string or GST_H265_PROFILE_INVALID on error

Since : 1.24

### gst_h264_quant_matrix_4x4_get_raster_from_zigzag

    void
    gst_h264_quant_matrix_4x4_get_raster_from_zigzag (guint8[16]  out_quant,
                                                      const guint8[16]  quant)

Converts quantization matrix quant from zigzag scan order to raster scan order and store the resulting factors into out_quant.

Note: it is an error to pass the same table in both quant and out_quant arguments.

Parameters:

`out_quant` –

The resulting quantization matrix

`quant` –

The source quantization matrix

Returns (void ) –
No description available

Since : 1.4

### gst_h264_quant_matrix_4x4_get_zigzag_from_raster

    void
    gst_h264_quant_matrix_4x4_get_zigzag_from_raster (guint8[16]  out_quant,
                                                      const guint8[16]  quant)

Converts quantization matrix quant from raster scan order to zigzag scan order and store the resulting factors into out_quant.

Note: it is an error to pass the same table in both quant and out_quant arguments.

Parameters:

`out_quant` –

The resulting quantization matrix

`quant` –

The source quantization matrix

Returns (void ) –
No description available

Since : 1.4

### gst_h264_quant_matrix_8x8_get_raster_from_zigzag

    void
    gst_h264_quant_matrix_8x8_get_raster_from_zigzag (guint8[64]  out_quant,
                                                      const guint8[64]  quant)

Converts quantization matrix quant from zigzag scan order to raster scan order and store the resulting factors into out_quant.

Note: it is an error to pass the same table in both quant and out_quant arguments.

Parameters:

`out_quant` –

The resulting quantization matrix

`quant` –

The source quantization matrix

Returns (void ) –
No description available

Since : 1.4

### gst_h264_quant_matrix_8x8_get_zigzag_from_raster

    void
    gst_h264_quant_matrix_8x8_get_zigzag_from_raster (guint8[64]  out_quant,
                                                      const guint8[64]  quant)

Converts quantization matrix quant from raster scan order to zigzag scan order and store the resulting factors into out_quant.

Note: it is an error to pass the same table in both quant and out_quant arguments.

Parameters:

`out_quant` –

The resulting quantization matrix

`quant` –

The source quantization matrix

Returns (void ) –
No description available

Since : 1.4

### gst_h264_sei_clear

    void
    gst_h264_sei_clear (GstH264SEIMessage * sei)

sei: The GstH264SEIMessage to clear

Parameters:

`sei` –
No description available
Returns (void ) –
No description available

### gst_h264_slice_type_to_string

    gchar *
    gst_h264_slice_type_to_string (GstH264SliceType slice_type)

Returns the descriptive name for the GstH264SliceType.

Parameters:

`slice_type` –

a GstH264SliceType

Returns (gchar *) –

the name for slice_type or NULL on error

Since : 1.24

### gst_h264_sps_clear

    void
    gst_h264_sps_clear (GstH264SPS * sps)

Clears all sps internal resources.

Parameters:

`sps` –

The GstH264SPS to free

Returns (void ) –
No description available

Since : 1.6

### gst_h264_video_calculate_framerate

    void
    gst_h264_video_calculate_framerate (GstH264SPS * sps,
                                        guint field_pic_flag,
                                        guint pic_struct,
                                        gint * fps_num,
                                        gint * fps_den)

Calculate framerate of a video sequence using sps VUI information, field_pic_flag from a slice header and pic_struct from GstH264PicTiming SEI message.

If framerate is variable or can't be determined, fps_num will be set to 0 and fps_den to 1.

Parameters:

`sps` –

Current Sequence Parameter Set

`field_pic_flag` –

Current field_pic_flag, obtained from latest slice header

`pic_struct` –

pic_struct value if available, 0 otherwise

`fps_num` –

The resulting fps numerator

`fps_den` –

The resulting fps denominator

Returns (void ) –
No description available

## Structures

### GstH264BufferingPeriod

    struct _GstH264BufferingPeriod
    {
      GstH264SPS *sps;

      /* seq->vui_parameters->nal_hrd_parameters_present_flag */
      guint32 nal_initial_cpb_removal_delay[32];
      guint32 nal_initial_cpb_removal_delay_offset[32];

      /* seq->vui_parameters->vcl_hrd_parameters_present_flag */
      guint32 vcl_initial_cpb_removal_delay[32];
      guint32 vcl_initial_cpb_removal_delay_offset[32];
    };

#### Fields

`sps` (GstH264SPS *) –
No description available
`nal_initial_cpb_removal_delay` (guint32[32] ) –
No description available
`nal_initial_cpb_removal_delay_offset` (guint32[32] ) –
No description available
`vcl_initial_cpb_removal_delay` (guint32[32] ) –
No description available
`vcl_initial_cpb_removal_delay_offset` (guint32[32] ) –
No description available

### GstH264ClockTimestamp

    struct _GstH264ClockTimestamp
    {
      guint8 ct_type;
      guint8 nuit_field_based_flag;
      guint8 counting_type;
      guint8 full_timestamp_flag;
      guint8 discontinuity_flag;
      guint8 cnt_dropped_flag;
      guint8 n_frames;

      guint8 seconds_flag;
      guint8 seconds_value;

      guint8 minutes_flag;
      guint8 minutes_value;

      guint8 hours_flag;
      guint8 hours_value;

      guint32 time_offset;
    };

#### Fields

`ct_type` (guint8) –

indicates the scan type, 0: progressive, 1: interlaced, 2: unknown, 3: reserved

`nuit_field_based_flag` (guint8) –

used in calculating clockTimestamp

`counting_type` (guint8) –

specifies the method of dropping values of the n_frames

`full_timestamp_flag` (guint8) –

equal to 1 specifies that the n_frames syntax element is followed by seconds_value, minutes_value, and hours_value (Since 1.18)

`discontinuity_flag` (guint8) –

indicates whether the difference between the current value of clockTimestamp and the value of clockTimestamp computed from the previous clock timestamp can be interpreted as the time difference or not.

`cnt_dropped_flag` (guint8) –

specifies the skipping of one or more values of n_frames using the counting method specified by counting_type

`n_frames` (guint8) –

specifies the value of nFrames used to compute clockTimestamp

`seconds_flag` (guint8) –

equal to 1 specifies that seconds_value and minutes_flag are present when full_timestamp_flag is equal to 0

`seconds_value` (guint8) –

specifies the value of seconds to compute clockTimestamp

`minutes_flag` (guint8) –

equal to 1 specifies that minutes_value and hours_flag are present when full_timestamp_flag is equal to 0 and seconds_flag is equal to 1

`minutes_value` (guint8) –

specifies the value of minutes to compute clockTimestamp

`hours_flag` (guint8) –

equal to 1 specifies that hours_value is present when full_timestamp_flag is equal to 0 and seconds_flag is equal to 1 and minutes_flag is equal to 1

`hours_value` (guint8) –
No description available
`time_offset` (guint32) –

specifies the value of tOffset used to compute clockTimestamp

### GstH264ContentLightLevel

    struct _GstH264ContentLightLevel
    {
      guint16 max_content_light_level;
      guint16 max_pic_average_light_level;
    };

The upper bounds for the nominal target brightness light level as specified in CEA-861.3

#### Fields

`max_content_light_level` (guint16) –
No description available
`max_pic_average_light_level` (guint16) –
No description available

### GstH264DecRefPicMarking

    struct _GstH264DecRefPicMarking
    {
      /* if slice->nal_unit.IdrPicFlag */
      guint8 no_output_of_prior_pics_flag;
      guint8 long_term_reference_flag;

      guint8 adaptive_ref_pic_marking_mode_flag;
      GstH264RefPicMarking ref_pic_marking[10];
      guint8 n_ref_pic_marking;

      /* Size of the dec_ref_pic_marking() syntax element in bits (Since: 1.18) */
      guint bit_size;
    };

#### Fields

`no_output_of_prior_pics_flag` (guint8) –
No description available
`long_term_reference_flag` (guint8) –
No description available
`adaptive_ref_pic_marking_mode_flag` (guint8) –
No description available
`ref_pic_marking` (GstH264RefPicMarking[10] ) –
No description available
`n_ref_pic_marking` (guint8) –
No description available
`bit_size` (guint) –
No description available

### GstH264DecoderConfigRecord

    struct _GstH264DecoderConfigRecord
    {
      /**
       * GstH264DecoderConfigRecord.configuration_version:
       *
       * Indicates configurationVersion, must be 1
       */
      guint8 configuration_version;

      /**
       * GstH264DecoderConfigRecord.profile_indication:
       *
       * H.264 profile indication
       */
      guint8 profile_indication;

      /**
       * GstH264DecoderConfigRecord.profile_compatibility:
       *
       * H.264 profile compatibility
       */
      guint8 profile_compatibility;

      /**
       * GstH264DecoderConfigRecord.level_indication:
       *
       * H.264 level indiction
       */
      guint8 level_indication;

      /**
       * GstH264DecoderConfigRecord.length_size_minus_one:
       *
       * Indicates the length in bytes of the NAL unit length field
       */
      guint8 length_size_minus_one;

      /**
       * GstH264DecoderConfigRecord.sps
       *
       * Array of identified #GstH264NalUnit from sequenceParameterSetNALUnit.
       * This array may contain non-SPS nal units such as SEI message
       */
      GArray *sps;

      /**
       * GstH264DecoderConfigRecord.pps
       *
       * Array of identified #GstH264NalUnit from pictureParameterSetNALUnit.
       * This array may contain non-PPS nal units such as SEI message
       */
      GArray *pps;

      /**
       * GstH264DecoderConfigRecord.chroma_format_present
       *
       * %TRUE if chroma information is present. Otherwise below values
       * have no meaning
       */
      gboolean chroma_format_present;

      /**
       * GstH264DecoderConfigRecord.chroma_format
       *
       * chroma_format_idc defined in ISO/IEC 14496-10
       */
      guint8 chroma_format;

      /**
       * GstH264DecoderConfigRecord.bit_depth_luma_minus8
       *
       * Indicates bit depth of luma component
       */
      guint8 bit_depth_luma_minus8;

      /**
       * GstH264DecoderConfigRecord.bit_depth_chroma_minus8
       *
       * Indicates bit depth of chroma component
       */
      guint8 bit_depth_chroma_minus8;

      /**
       * GstH264DecoderConfigRecord.sps_ext
       *
       * Array of identified #GstH264NalUnit from sequenceParameterSetExtNALUnit.
       */
      GArray *sps_ext;

    };

Contains AVCDecoderConfigurationRecord data as defined in ISO/IEC 14496-15

#### Fields

`configuration_version` (guint8) –
No description available
`profile_indication` (guint8) –
No description available
`profile_compatibility` (guint8) –
No description available
`level_indication` (guint8) –
No description available
`length_size_minus_one` (guint8) –
No description available
`sps` (GArray *) –
No description available
`pps` (GArray *) –
No description available
`chroma_format_present` (gboolean) –
No description available
`chroma_format` (guint8) –
No description available
`bit_depth_luma_minus8` (guint8) –
No description available
`bit_depth_chroma_minus8` (guint8) –
No description available
`sps_ext` (GArray *) –
No description available

Since : 1.22

### GstH264FramePacking

    struct _GstH264FramePacking
    {
      guint32 frame_packing_id;
      guint8 frame_packing_cancel_flag;
      guint8 frame_packing_type; /* GstH264FramePackingType */
      guint8 quincunx_sampling_flag;
      guint8 content_interpretation_type;
      guint8 spatial_flipping_flag;
      guint8 frame0_flipped_flag;
      guint8 field_views_flag;
      guint8 current_frame_is_frame0_flag;
      guint8 frame0_self_contained_flag;
      guint8 frame1_self_contained_flag;
      guint8 frame0_grid_position_x;
      guint8 frame0_grid_position_y;
      guint8 frame1_grid_position_x;
      guint8 frame1_grid_position_y;
      guint16 frame_packing_repetition_period;
    };

#### Fields

`frame_packing_id` (guint32) –
No description available
`frame_packing_cancel_flag` (guint8) –
No description available
`frame_packing_type` (guint8) –
No description available
`quincunx_sampling_flag` (guint8) –
No description available
`content_interpretation_type` (guint8) –
No description available
`spatial_flipping_flag` (guint8) –
No description available
`frame0_flipped_flag` (guint8) –
No description available
`field_views_flag` (guint8) –
No description available
`current_frame_is_frame0_flag` (guint8) –
No description available
`frame0_self_contained_flag` (guint8) –
No description available
`frame1_self_contained_flag` (guint8) –
No description available
`frame0_grid_position_x` (guint8) –
No description available
`frame0_grid_position_y` (guint8) –
No description available
`frame1_grid_position_x` (guint8) –
No description available
`frame1_grid_position_y` (guint8) –
No description available
`frame_packing_repetition_period` (guint16) –
No description available

Since : 1.6

### GstH264HRDParams

    struct _GstH264HRDParams
    {
      guint8 cpb_cnt_minus1;
      guint8 bit_rate_scale;
      guint8 cpb_size_scale;

      guint32 bit_rate_value_minus1[32];
      guint32 cpb_size_value_minus1[32];
      guint8 cbr_flag[32];

      guint8 initial_cpb_removal_delay_length_minus1;
      guint8 cpb_removal_delay_length_minus1;
      guint8 dpb_output_delay_length_minus1;
      guint8 time_offset_length;
    };

Defines the HRD parameters

#### Fields

`cpb_cnt_minus1` (guint8) –

plus 1 specifies the number of alternative CPB specifications in the bitstream

`bit_rate_scale` (guint8) –

specifies the maximum input bit rate of the SchedSelIdx-th CPB

`cpb_size_scale` (guint8) –

specifies the CPB size of the SchedSelIdx-th CPB guint32 bit_rate_value_minus1: specifies the maximum input bit rate for the SchedSelIdx-th CPB

`bit_rate_value_minus1` (guint32[32] ) –
No description available
`cpb_size_value_minus1` (guint32[32] ) –

is used together with cpb_size_scale to specify the SchedSelIdx-th CPB size

`cbr_flag` (guint8[32] ) –

Specifies if running in constant or intermittent bit rate mode

`initial_cpb_removal_delay_length_minus1` (guint8) –

specifies the length in bits of the cpb_removal_delay syntax element

`cpb_removal_delay_length_minus1` (guint8) –

specifies the length in bits of the dpb_output_delay syntax element

`dpb_output_delay_length_minus1` (guint8) –

> 0 specifies the length in bits of the time_offset syntax element. =0 specifies that the time_offset syntax element is not present

`time_offset_length` (guint8) –

Length of the time offset

### GstH264MasteringDisplayColourVolume

    struct _GstH264MasteringDisplayColourVolume
    {
      guint16 display_primaries_x[3];
      guint16 display_primaries_y[3];
      guint16 white_point_x;
      guint16 white_point_y;
      guint32 max_display_mastering_luminance;
      guint32 min_display_mastering_luminance;
    };

The colour volume (primaries, white point and luminance range) of display defined by SMPTE ST 2086.

#### Fields

`display_primaries_x` (guint16[3] ) –
No description available
`display_primaries_y` (guint16[3] ) –
No description available
`white_point_x` (guint16) –
No description available
`white_point_y` (guint16) –
No description available
`max_display_mastering_luminance` (guint32) –
No description available
`min_display_mastering_luminance` (guint32) –
No description available

### GstH264NalParser

H264 NAL Parser (opaque structure).

### GstH264NalUnit

    struct _GstH264NalUnit
    {
      guint16 ref_idc;
      guint16 type;

      /* calculated values */
      guint8 idr_pic_flag;
      guint size;
      guint offset;
      guint sc_offset;
      gboolean valid;

      guint8 *data;

      guint8 header_bytes;
      guint8 extension_type;
      union {
        GstH264NalUnitExtensionMVC mvc;
      } extension;
    };

Structure defining the NAL unit headers

#### Fields

`ref_idc` (guint16) –

not equal to 0 specifies that the content of the NAL unit contains a sequence parameter set, a sequence parameter set extension, a subset sequence parameter set, a picture parameter set, a slice of a reference picture, a slice data partition of a reference picture, or a prefix NAL unit preceding a slice of a reference picture.

`type` (guint16) –

A GstH264NalUnitType

`idr_pic_flag` (guint8) –

calculated idr_pic_flag

`size` (guint) –

The size of the NAL unit starting from offset, thus including the header bytes. e.g. type (nal_unit_type), but not the start code.

`offset` (guint) –

The offset of the first byte of the NAL unit header, just after the start code.

`sc_offset` (guint) –

The offset of the first byte of the start code of the NAL unit.

`valid` (gboolean) –

If the NAL unit is valid, which means it has already been parsed

`data` (guint8 *) –

The data array from which the NAL unit has been parsed, into which the offset and sc_offset apply.

`header_bytes` (guint8) –

The size of the NALU header in bytes. The NALU header is the 1-byte type code, and for extension / prefix NALs includes the extension header bytes. offset + header_bytes is therefore the first byte of the actual packet payload. (Since: 1.6)

`extension_type` (guint8) –

the extension type for prefix NAL/MVC/SVC (Since: 1.6)

`extension.mvc` (GstH264NalUnitExtensionMVC) –
No description available

### GstH264NalUnitExtensionMVC

    struct _GstH264NalUnitExtensionMVC
    {
      guint8 non_idr_flag;
      guint8 priority_id;
      guint16 view_id;
      guint8 temporal_id;
      guint8 anchor_pic_flag;
      guint8 inter_view_flag;
    };

#### Fields

`non_idr_flag` (guint8) –

If equal to 0, it specifies that the current access unit is an IDR access unit

`priority_id` (guint8) –

The priority identifier for the NAL unit

`view_id` (guint16) –

The view identifier for the NAL unit

`temporal_id` (guint8) –

The temporal identifier for the NAL unit

`anchor_pic_flag` (guint8) –

If equal to 1, it specifies that the current access unit is an anchor access unit

`inter_view_flag` (guint8) –

If equal to 0, it specifies that the current view component is not used for inter-view prediction by any other view component in the current access unit

Since : 1.6

### GstH264PPS

    struct _GstH264PPS
    {
      gint id;

      GstH264SPS *sequence;

      guint8 entropy_coding_mode_flag;
      guint8 pic_order_present_flag;

      guint32 num_slice_groups_minus1;

      /* if num_slice_groups_minus1 > 0 */
      guint8 slice_group_map_type;
      /* and if slice_group_map_type == 0 */
      guint32 run_length_minus1[8];
      /* or if slice_group_map_type == 2 */
      guint32 top_left[8];
      guint32 bottom_right[8];
      /* or if slice_group_map_type == (3, 4, 5) */
      guint8 slice_group_change_direction_flag;
      guint32 slice_group_change_rate_minus1;
      /* or if slice_group_map_type == 6 */
      guint32 pic_size_in_map_units_minus1;
      guint8 *slice_group_id;

      /* FIXME rename to num_ref_idx_l{0,1}_default_active_minus1 */
      guint8 num_ref_idx_l0_active_minus1;
      guint8 num_ref_idx_l1_active_minus1;
      guint8 weighted_pred_flag;
      guint8 weighted_bipred_idc;
      gint8 pic_init_qp_minus26;
      gint8 pic_init_qs_minus26;
      gint8 chroma_qp_index_offset;
      guint8 deblocking_filter_control_present_flag;
      guint8 constrained_intra_pred_flag;
      guint8 redundant_pic_cnt_present_flag;

      guint8 transform_8x8_mode_flag;

      guint8 scaling_lists_4x4[6][16];
      guint8 scaling_lists_8x8[6][64];

      gint8 second_chroma_qp_index_offset;

      gboolean valid;

      /* Since: 1.18 */
      guint8 pic_scaling_matrix_present_flag;
    };

H264 Picture Parameter Set

#### Fields

`id` (gint) –
No description available
`sequence` (GstH264SPS *) –
No description available
`entropy_coding_mode_flag` (guint8) –
No description available
`pic_order_present_flag` (guint8) –
No description available
`num_slice_groups_minus1` (guint32) –
No description available
`slice_group_map_type` (guint8) –
No description available
`run_length_minus1` (guint32[8] ) –
No description available
`top_left` (guint32[8] ) –
No description available
`bottom_right` (guint32[8] ) –
No description available
`slice_group_change_direction_flag` (guint8) –
No description available
`slice_group_change_rate_minus1` (guint32) –
No description available
`pic_size_in_map_units_minus1` (guint32) –
No description available
`slice_group_id` (guint8 *) –
No description available
`num_ref_idx_l0_active_minus1` (guint8) –
No description available
`num_ref_idx_l1_active_minus1` (guint8) –
No description available
`weighted_pred_flag` (guint8) –
No description available
`weighted_bipred_idc` (guint8) –
No description available
`pic_init_qp_minus26` (gint8) –
No description available
`pic_init_qs_minus26` (gint8) –
No description available
`chroma_qp_index_offset` (gint8) –
No description available
`deblocking_filter_control_present_flag` (guint8) –
No description available
`constrained_intra_pred_flag` (guint8) –
No description available
`redundant_pic_cnt_present_flag` (guint8) –
No description available
`transform_8x8_mode_flag` (guint8) –
No description available
`scaling_lists_4x4` (guint8[6][16] ) –
No description available
`scaling_lists_8x8` (guint8[6][64] ) –
No description available
`second_chroma_qp_index_offset` (gint8) –
No description available
`valid` (gboolean) –
No description available
`pic_scaling_matrix_present_flag` (guint8) –
No description available

### GstH264PicTiming

    struct _GstH264PicTiming
    {
      /* from vui */
      guint8 CpbDpbDelaysPresentFlag;
      /* if CpbDpbDelaysPresentFlag */
      guint8 cpb_removal_delay_length_minus1;
      guint8 dpb_output_delay_length_minus1;
      guint32 cpb_removal_delay;
      guint32 dpb_output_delay;

      guint8 pic_struct_present_flag;
      /* if pic_struct_present_flag */
      guint8 pic_struct;

      guint8 clock_timestamp_flag[3];
      GstH264ClockTimestamp clock_timestamp[3];
      guint8 time_offset_length;
    };

#### Fields

`CpbDpbDelaysPresentFlag` (guint8) –

non-zero if linked GstH264VUIParams::nal_hrd_parameters_present_flag or GstH264VUIParams::vcl_hrd_parameters_present_flag is non-zero (Since: 1.18)

`cpb_removal_delay_length_minus1` (guint8) –

specifies the length of cpb_removal_delay in bits (Since 1.18)

`dpb_output_delay_length_minus1` (guint8) –

specifies the length of dpb_output_delay in bits (Since 1.18)

`cpb_removal_delay` (guint32) –

specifies how many clock ticks to wait after removal from the CPB of the access unit associated with the most recent buffering period SEI message in a preceding access unit before removing from the buffer the access unit data associated with the picture timing SEI message

`dpb_output_delay` (guint32) –

used to compute the DPB output time of the picture

`pic_struct_present_flag` (guint8) –

GstH264VUIParams::pic_struct_present_flag

`pic_struct` (guint8) –

indicates whether a picture should be displayed as a frame or one or more fields

`clock_timestamp_flag` (guint8[3] ) –

equal to 1 indicates that a number of clock timestamp syntax elements are present

`clock_timestamp` (GstH264ClockTimestamp[3] ) –

a GstH264ClockTimestamp

`time_offset_length` (guint8) –

specifies the length time_offset of GstH264ClockTimestamp in bits (Since 1.18)

### GstH264PredWeightTable

    struct _GstH264PredWeightTable
    {
      guint8 luma_log2_weight_denom;
      guint8 chroma_log2_weight_denom;

      gint16 luma_weight_l0[32];
      gint8 luma_offset_l0[32];

      /* if seq->ChromaArrayType != 0 */
      gint16 chroma_weight_l0[32][2];
      gint8 chroma_offset_l0[32][2];

      /* if slice->slice_type % 5 == 1 */
      gint16 luma_weight_l1[32];
      gint8 luma_offset_l1[32];

      /* and if seq->ChromaArrayType != 0 */
      gint16 chroma_weight_l1[32][2];
      gint8 chroma_offset_l1[32][2];
    };

#### Fields

`luma_log2_weight_denom` (guint8) –
No description available
`chroma_log2_weight_denom` (guint8) –
No description available
`luma_weight_l0` (gint16[32] ) –
No description available
`luma_offset_l0` (gint8[32] ) –
No description available
`chroma_weight_l0` (gint16[32][2] ) –
No description available
`chroma_offset_l0` (gint8[32][2] ) –
No description available
`luma_weight_l1` (gint16[32] ) –
No description available
`luma_offset_l1` (gint8[32] ) –
No description available
`chroma_weight_l1` (gint16[32][2] ) –
No description available
`chroma_offset_l1` (gint8[32][2] ) –
No description available

### GstH264RecoveryPoint

    struct _GstH264RecoveryPoint
    {
      guint32 recovery_frame_cnt;
      guint8 exact_match_flag;
      guint8 broken_link_flag;
      guint8 changing_slice_group_idc;
    };

#### Fields

`recovery_frame_cnt` (guint32) –
No description available
`exact_match_flag` (guint8) –
No description available
`broken_link_flag` (guint8) –
No description available
`changing_slice_group_idc` (guint8) –
No description available

### GstH264RefPicListModification

    struct _GstH264RefPicListModification
    {
      guint8 modification_of_pic_nums_idc;
      union
      {
        /* if modification_of_pic_nums_idc == 0 || 1 */
        guint32 abs_diff_pic_num_minus1;
        /* if modification_of_pic_nums_idc == 2 */
        guint32 long_term_pic_num;
        /* if modification_of_pic_nums_idc == 4 || 5 */
        guint32 abs_diff_view_idx_minus1;
      } value;
    };

#### Fields

`modification_of_pic_nums_idc` (guint8) –
No description available
`value.abs_diff_pic_num_minus1` (guint32) –
No description available
`value.long_term_pic_num` (guint32) –
No description available
`value.abs_diff_view_idx_minus1` (guint32) –
No description available

### GstH264RefPicMarking

    struct _GstH264RefPicMarking
    {
      guint8 memory_management_control_operation;

      guint32 difference_of_pic_nums_minus1;
      guint32 long_term_pic_num;
      guint32 long_term_frame_idx;
      guint32 max_long_term_frame_idx_plus1;
    };

#### Fields

`memory_management_control_operation` (guint8) –
No description available
`difference_of_pic_nums_minus1` (guint32) –
No description available
`long_term_pic_num` (guint32) –
No description available
`long_term_frame_idx` (guint32) –
No description available
`max_long_term_frame_idx_plus1` (guint32) –
No description available

### GstH264RegisteredUserData

    struct _GstH264RegisteredUserData
    {
      guint8 country_code;
      guint8 country_code_extension;
      const guint8 *data;
      guint size;
    };

The User data registered by Rec. ITU-T T.35 SEI messag. country_code: an itu_t_t35_country_code. country_code_extension: an itu_t_t35_country_code_extension_byte. Should be ignored when country_code is not 0xff data: the data of itu_t_t35_payload_byte excluding country_code and country_code_extension size: the size of data in bytes

#### Fields

`country_code` (guint8) –
No description available
`country_code_extension` (guint8) –
No description available
`data` (guint8 *) –
No description available
`size` (guint) –
No description available

### GstH264SEIMessage

    struct _GstH264SEIMessage
    {
      GstH264SEIPayloadType payloadType;

      union {
        GstH264BufferingPeriod buffering_period;
        GstH264PicTiming pic_timing;
        GstH264RegisteredUserData registered_user_data;
        GstH264RecoveryPoint recovery_point;
        GstH264StereoVideoInfo stereo_video_info;
        GstH264FramePacking frame_packing;
        GstH264MasteringDisplayColourVolume mastering_display_colour_volume;
        GstH264ContentLightLevel content_light_level;
        GstH264SEIUnhandledPayload unhandled_payload;
        GstH264UserDataUnregistered user_data_unregistered;
        /* ... could implement more */
      } payload;
    };

#### Fields

`payloadType` (GstH264SEIPayloadType) –
No description available
`payload.buffering_period` (GstH264BufferingPeriod) –
No description available
`payload.pic_timing` (GstH264PicTiming) –
No description available
`payload.registered_user_data` (GstH264RegisteredUserData) –
No description available
`payload.recovery_point` (GstH264RecoveryPoint) –
No description available
`payload.stereo_video_info` (GstH264StereoVideoInfo) –
No description available
`payload.frame_packing` (GstH264FramePacking) –
No description available
`payload.mastering_display_colour_volume` (GstH264MasteringDisplayColourVolume) –
No description available
`payload.content_light_level` (GstH264ContentLightLevel) –
No description available
`payload.unhandled_payload` (GstH264SEIUnhandledPayload) –
No description available
`payload.user_data_unregistered` (GstH264UserDataUnregistered) –

User Data Unregistered

### GstH264SEIUnhandledPayload

    struct _GstH264SEIUnhandledPayload
    {
      guint payloadType;

      guint8 *data;
      guint size;
    };

Contains unhandled SEI payload data. This SEI may or may not be defined by spec

#### Fields

`payloadType` (guint) –

Payload type

`data` (guint8 *) –

payload raw data excluding payload type and payload size byte

`size` (guint) –

the size of data

Since : 1.18

### GstH264SPS

    struct _GstH264SPS
    {
      gint id;

      guint8 profile_idc;
      guint8 constraint_set0_flag;
      guint8 constraint_set1_flag;
      guint8 constraint_set2_flag;
      guint8 constraint_set3_flag;
      guint8 constraint_set4_flag;
      guint8 constraint_set5_flag;
      guint8 level_idc;

      guint8 chroma_format_idc;
      guint8 separate_colour_plane_flag;
      guint8 bit_depth_luma_minus8;
      guint8 bit_depth_chroma_minus8;
      guint8 qpprime_y_zero_transform_bypass_flag;

      guint8 scaling_matrix_present_flag;
      guint8 scaling_lists_4x4[6][16];
      guint8 scaling_lists_8x8[6][64];

      guint8 log2_max_frame_num_minus4;
      guint8 pic_order_cnt_type;

      /* if pic_order_cnt_type == 0 */
      guint8 log2_max_pic_order_cnt_lsb_minus4;

      /* else if pic_order_cnt_type == 1 */
      guint8 delta_pic_order_always_zero_flag;
      gint32 offset_for_non_ref_pic;
      gint32 offset_for_top_to_bottom_field;
      guint8 num_ref_frames_in_pic_order_cnt_cycle;
      gint32 offset_for_ref_frame[255];

      /* FIXME rename according to spec, max_num_ref_frames */
      guint32 num_ref_frames;
      guint8 gaps_in_frame_num_value_allowed_flag;
      guint32 pic_width_in_mbs_minus1;
      guint32 pic_height_in_map_units_minus1;
      guint8 frame_mbs_only_flag;

      guint8 mb_adaptive_frame_field_flag;

      guint8 direct_8x8_inference_flag;

      guint8 frame_cropping_flag;

      /* if frame_cropping_flag */
      guint32 frame_crop_left_offset;
      guint32 frame_crop_right_offset;
      guint32 frame_crop_top_offset;
      guint32 frame_crop_bottom_offset;

      guint8 vui_parameters_present_flag;
      /* if vui_parameters_present_flag */
      GstH264VUIParams vui_parameters;

      /* calculated values */
      guint8 chroma_array_type;
      guint32 max_frame_num;
      gint width, height;
      gint crop_rect_width, crop_rect_height;
      gint crop_rect_x, crop_rect_y;
      gint fps_num_removed, fps_den_removed; /* FIXME: remove */
      gboolean valid;

      /* Subset SPS extensions */
      guint8 extension_type;
      union {
        GstH264SPSExtMVC mvc;
      } extension;
    };

H264 Sequence Parameter Set (SPS)

#### Fields

`id` (gint) –

The ID of the sequence parameter set

`profile_idc` (guint8) –

indicate the profile to which the coded video sequence conforms

`constraint_set0_flag` (guint8) –
No description available
`constraint_set1_flag` (guint8) –
No description available
`constraint_set2_flag` (guint8) –
No description available
`constraint_set3_flag` (guint8) –
No description available
`constraint_set4_flag` (guint8) –
No description available
`constraint_set5_flag` (guint8) –
No description available
`level_idc` (guint8) –
No description available
`chroma_format_idc` (guint8) –
No description available
`separate_colour_plane_flag` (guint8) –
No description available
`bit_depth_luma_minus8` (guint8) –
No description available
`bit_depth_chroma_minus8` (guint8) –
No description available
`qpprime_y_zero_transform_bypass_flag` (guint8) –
No description available
`scaling_matrix_present_flag` (guint8) –
No description available
`scaling_lists_4x4` (guint8[6][16] ) –
No description available
`scaling_lists_8x8` (guint8[6][64] ) –
No description available
`log2_max_frame_num_minus4` (guint8) –
No description available
`pic_order_cnt_type` (guint8) –
No description available
`log2_max_pic_order_cnt_lsb_minus4` (guint8) –
No description available
`delta_pic_order_always_zero_flag` (guint8) –
No description available
`offset_for_non_ref_pic` (gint32) –
No description available
`offset_for_top_to_bottom_field` (gint32) –
No description available
`num_ref_frames_in_pic_order_cnt_cycle` (guint8) –
No description available
`offset_for_ref_frame` (gint32[255] ) –
No description available
`num_ref_frames` (guint32) –
No description available
`gaps_in_frame_num_value_allowed_flag` (guint8) –
No description available
`pic_width_in_mbs_minus1` (guint32) –
No description available
`pic_height_in_map_units_minus1` (guint32) –
No description available
`frame_mbs_only_flag` (guint8) –
No description available
`mb_adaptive_frame_field_flag` (guint8) –
No description available
`direct_8x8_inference_flag` (guint8) –
No description available
`frame_cropping_flag` (guint8) –
No description available
`frame_crop_left_offset` (guint32) –
No description available
`frame_crop_right_offset` (guint32) –
No description available
`frame_crop_top_offset` (guint32) –
No description available
`frame_crop_bottom_offset` (guint32) –
No description available
`vui_parameters_present_flag` (guint8) –
No description available
`vui_parameters` (GstH264VUIParams) –
No description available
`chroma_array_type` (guint8) –
No description available
`max_frame_num` (guint32) –
No description available
`width` (gint) –
No description available
`height` (gint) –
No description available
`crop_rect_width` (gint) –
No description available
`crop_rect_height` (gint) –
No description available
`crop_rect_x` (gint) –
No description available
`crop_rect_y` (gint) –
No description available
`fps_num_removed` (gint) –
No description available
`fps_den_removed` (gint) –
No description available
`valid` (gboolean) –
No description available
`extension_type` (guint8) –
No description available
`extension.mvc` (GstH264SPSExtMVC) –
No description available

### GstH264SPSExtMVC

    struct _GstH264SPSExtMVC
    {
      guint16 num_views_minus1;
      GstH264SPSExtMVCView *view;
      guint8 num_level_values_signalled_minus1;
      GstH264SPSExtMVCLevelValue *level_value;
    };

Represents the parsed `seq_parameter_set_mvc_extension()`.

#### Fields

`num_views_minus1` (guint16) –

plus 1 specifies the maximum number of coded views in the coded video sequence

`view` (GstH264SPSExtMVCView *) –

array of GstH264SPSExtMVCView

`num_level_values_signalled_minus1` (guint8) –

plus 1 specifies the number of level values signalled for the coded video sequence.

`level_value` (GstH264SPSExtMVCLevelValue *) –

array of GstH264SPSExtMVCLevelValue

Since : 1.6

### GstH264SPSExtMVCLevelValue

    struct _GstH264SPSExtMVCLevelValue
    {
      guint8 level_idc;
      guint16 num_applicable_ops_minus1;
      GstH264SPSExtMVCLevelValueOp *applicable_op;
    };

Represents level values for a subset of the operation points for the coded video sequence.

#### Fields

`level_idc` (guint8) –

specifies the level value signalled for the coded video sequence

`num_applicable_ops_minus1` (guint16) –

plus 1 specifies the number of operation points to which the level indicated by level_idc applies

`applicable_op` (GstH264SPSExtMVCLevelValueOp *) –

specifies the applicable operation point

Since : 1.6

### GstH264SPSExtMVCLevelValueOp

    struct _GstH264SPSExtMVCLevelValueOp
    {
      guint8 temporal_id;
      guint16 num_target_views_minus1;
      guint16 *target_view_id;
      guint16 num_views_minus1;
    };

Represents an operation point for the coded video sequence.

#### Fields

`temporal_id` (guint8) –
No description available
`num_target_views_minus1` (guint16) –
No description available
`target_view_id` (guint16 *) –
No description available
`num_views_minus1` (guint16) –
No description available

Since : 1.6

### GstH264SPSExtMVCView

    struct _GstH264SPSExtMVCView
    {
      guint16 view_id;
      guint8 num_anchor_refs_l0;
      guint16 anchor_ref_l0[15];
      guint8 num_anchor_refs_l1;
      guint16 anchor_ref_l1[15];
      guint8 num_non_anchor_refs_l0;
      guint16 non_anchor_ref_l0[15];
      guint8 num_non_anchor_refs_l1;
      guint16 non_anchor_ref_l1[15];
    };

Represents inter-view dependency relationships for the coded video sequence.

#### Fields

`view_id` (guint16) –
No description available
`num_anchor_refs_l0` (guint8) –

specifies the number of view components for inter-view prediction in the initialized RefPicList0 in decoding anchor view components.

`anchor_ref_l0` (guint16[15] ) –

specifies the view_id for inter-view prediction in the initialized RefPicList0 in decoding anchor view components.

`num_anchor_refs_l1` (guint8) –

specifies the number of view components for inter-view prediction in the initialized RefPicList1 in decoding anchor view components.

`anchor_ref_l1` (guint16[15] ) –

specifies the view_id for inter-view prediction in the initialized RefPicList1 in decoding anchor view components.

`num_non_anchor_refs_l0` (guint8) –

specifies the number of view components for inter-view prediction in the initialized RefPicList0 in decoding non-anchor view components.

`non_anchor_ref_l0` (guint16[15] ) –

specifies the view_id for inter-view prediction in the initialized RefPicList0 in decoding non-anchor view components.

`num_non_anchor_refs_l1` (guint8) –

specifies the number of view components for inter-view prediction in the initialized RefPicList1 in decoding non-anchor view components.

`non_anchor_ref_l1` (guint16[15] ) –

specifies the view_id for inter-view prediction in the initialized RefPicList1 in decoding non-anchor view components.

Since : 1.6

### GstH264SliceHdr

    struct _GstH264SliceHdr
    {
      guint32 first_mb_in_slice;
      guint32 type;
      GstH264PPS *pps;

      /* if seq->separate_colour_plane_flag */
      guint8 colour_plane_id;

      guint16 frame_num;

      guint8 field_pic_flag;
      guint8 bottom_field_flag;

      /* if nal_unit.type == 5 */
      guint16 idr_pic_id;

      /* if seq->pic_order_cnt_type == 0 */
      guint16 pic_order_cnt_lsb;
      /* if seq->pic_order_present_flag && !field_pic_flag */
      gint32 delta_pic_order_cnt_bottom;

      gint32 delta_pic_order_cnt[2];
      guint8 redundant_pic_cnt;

      /* if slice_type == B_SLICE */
      guint8 direct_spatial_mv_pred_flag;

      guint8 num_ref_idx_l0_active_minus1;
      guint8 num_ref_idx_l1_active_minus1;

      guint8 ref_pic_list_modification_flag_l0;
      guint8 n_ref_pic_list_modification_l0;
      GstH264RefPicListModification ref_pic_list_modification_l0[32];
      guint8 ref_pic_list_modification_flag_l1;
      guint8 n_ref_pic_list_modification_l1;
      GstH264RefPicListModification ref_pic_list_modification_l1[32];

      GstH264PredWeightTable pred_weight_table;
      /* if nal_unit.ref_idc != 0 */
      GstH264DecRefPicMarking dec_ref_pic_marking;

      guint8 cabac_init_idc;
      gint8 slice_qp_delta;
      gint8 slice_qs_delta;

      guint8 disable_deblocking_filter_idc;
      gint8 slice_alpha_c0_offset_div2;
      gint8 slice_beta_offset_div2;

      guint16 slice_group_change_cycle;

      /* calculated values */
      guint32 max_pic_num;
      gboolean valid;

      /* Size of the slice_header() in bits */
      guint header_size;

      /* Number of emulation prevention bytes (EPB) in this slice_header() */
      guint n_emulation_prevention_bytes;

      /* Since: 1.18 */
      guint8 num_ref_idx_active_override_flag;
      guint8 sp_for_switch_flag;

      /*
       * Size of the pic_order_cnt related syntax elements pic_order_cnt_lsb,
       * delta_pic_order_cnt_bottom, delta_pic_order_cnt[0], and
       * delta_pic_order_cnt[1]. (Since: 1.18)
       */
      guint pic_order_cnt_bit_size;
    };

#### Fields

`first_mb_in_slice` (guint32) –
No description available
`type` (guint32) –
No description available
`pps` (GstH264PPS *) –
No description available
`colour_plane_id` (guint8) –
No description available
`frame_num` (guint16) –
No description available
`field_pic_flag` (guint8) –
No description available
`bottom_field_flag` (guint8) –
No description available
`idr_pic_id` (guint16) –
No description available
`pic_order_cnt_lsb` (guint16) –
No description available
`delta_pic_order_cnt_bottom` (gint32) –
No description available
`delta_pic_order_cnt` (gint32[2] ) –
No description available
`redundant_pic_cnt` (guint8) –
No description available
`direct_spatial_mv_pred_flag` (guint8) –
No description available
`num_ref_idx_l0_active_minus1` (guint8) –
No description available
`num_ref_idx_l1_active_minus1` (guint8) –
No description available
`ref_pic_list_modification_flag_l0` (guint8) –
No description available
`n_ref_pic_list_modification_l0` (guint8) –
No description available
`ref_pic_list_modification_l0` (GstH264RefPicListModification[32] ) –
No description available
`ref_pic_list_modification_flag_l1` (guint8) –
No description available
`n_ref_pic_list_modification_l1` (guint8) –
No description available
`ref_pic_list_modification_l1` (GstH264RefPicListModification[32] ) –
No description available
`pred_weight_table` (GstH264PredWeightTable) –
No description available
`dec_ref_pic_marking` (GstH264DecRefPicMarking) –
No description available
`cabac_init_idc` (guint8) –
No description available
`slice_qp_delta` (gint8) –
No description available
`slice_qs_delta` (gint8) –
No description available
`disable_deblocking_filter_idc` (guint8) –
No description available
`slice_alpha_c0_offset_div2` (gint8) –
No description available
`slice_beta_offset_div2` (gint8) –
No description available
`slice_group_change_cycle` (guint16) –
No description available
`max_pic_num` (guint32) –
No description available
`valid` (gboolean) –
No description available
`header_size` (guint) –
No description available
`n_emulation_prevention_bytes` (guint) –
No description available
`num_ref_idx_active_override_flag` (guint8) –
No description available
`sp_for_switch_flag` (guint8) –
No description available
`pic_order_cnt_bit_size` (guint) –
No description available

### GstH264StereoVideoInfo

    struct _GstH264StereoVideoInfo
    {
      guint8 field_views_flag;
      guint8 top_field_is_left_view_flag;
      guint8 current_frame_is_left_view_flag;
      guint8 next_frame_is_second_view_flag;
      guint8 left_view_self_contained_flag;
      guint8 right_view_self_contained_flag;
    };

#### Fields

`field_views_flag` (guint8) –
No description available
`top_field_is_left_view_flag` (guint8) –
No description available
`current_frame_is_left_view_flag` (guint8) –
No description available
`next_frame_is_second_view_flag` (guint8) –
No description available
`left_view_self_contained_flag` (guint8) –
No description available
`right_view_self_contained_flag` (guint8) –
No description available

Since : 1.6

### GstH264UserDataUnregistered

    struct _GstH264UserDataUnregistered
    {
      guint8 uuid[16];
      const guint8 *data;
      guint size;
    };

The User data unregistered SEI message syntax.

#### Fields

`uuid` (guint8[16] ) –

an uuid_iso_iec_11578.

`data` (guint8 *) –

the data of user_data_payload_byte

`size` (guint) –

the size of data in bytes

Since : 1.22

### GstH264VUIParams

    struct _GstH264VUIParams
    {
      guint8 aspect_ratio_info_present_flag;
      guint8 aspect_ratio_idc;
      /* if aspect_ratio_idc == 255 */
      guint16 sar_width;
      guint16 sar_height;

      guint8 overscan_info_present_flag;
      /* if overscan_info_present_flag */
      guint8 overscan_appropriate_flag;

      guint8 video_signal_type_present_flag;
      guint8 video_format;
      guint8 video_full_range_flag;
      guint8 colour_description_present_flag;
      guint8 colour_primaries;
      guint8 transfer_characteristics;
      guint8 matrix_coefficients;

      guint8 chroma_loc_info_present_flag;
      guint8 chroma_sample_loc_type_top_field;
      guint8 chroma_sample_loc_type_bottom_field;

      guint8 timing_info_present_flag;
      /* if timing_info_present_flag */
      guint32 num_units_in_tick;
      guint32 time_scale;
      guint8 fixed_frame_rate_flag;

      guint8 nal_hrd_parameters_present_flag;
      /* if nal_hrd_parameters_present_flag */
      GstH264HRDParams nal_hrd_parameters;

      guint8 vcl_hrd_parameters_present_flag;
      /* if vcl_hrd_parameters_present_flag */
      GstH264HRDParams vcl_hrd_parameters;

      guint8 low_delay_hrd_flag;
      guint8 pic_struct_present_flag;

      guint8 bitstream_restriction_flag;
      /*  if bitstream_restriction_flag */
      guint8 motion_vectors_over_pic_boundaries_flag;
      guint32 max_bytes_per_pic_denom;
      guint32 max_bits_per_mb_denom;
      guint32 log2_max_mv_length_horizontal;
      guint32 log2_max_mv_length_vertical;
      guint32 num_reorder_frames;
      guint32 max_dec_frame_buffering;

      /* calculated values */
      guint par_n;
      guint par_d;
    };

The structure representing the VUI parameters.

#### Fields

`aspect_ratio_info_present_flag` (guint8) –

TRUE specifies that aspect_ratio_idc is present. FALSE specifies that aspect_ratio_idc is not present aspect_ratio_idc specifies the value of the sample aspect ratio of the luma samples sar_width indicates the horizontal size of the sample aspect ratio sar_height indicates the vertical size of the sample aspect ratio

`aspect_ratio_idc` (guint8) –
No description available
`sar_width` (guint16) –
No description available
`sar_height` (guint16) –
No description available
`overscan_info_present_flag` (guint8) –

TRUE overscan_appropriate_flag is present FALSE otherwise

`overscan_appropriate_flag` (guint8) –

TRUE indicates that the cropped decoded pictures output are suitable for display using overscan. FALSE the cropped decoded pictures output contain visually important information

`video_signal_type_present_flag` (guint8) –

TRUE specifies that video_format, video_full_range_flag and colour_description_present_flag are present.

`video_format` (guint8) –

indicates the representation of the picture

`video_full_range_flag` (guint8) –

indicates the black level and range of the luma and chroma signals

`colour_description_present_flag` (guint8) –

TRUE specifies that colour_primaries, transfer_characteristics and matrix_coefficients are present

`colour_primaries` (guint8) –

indicates the chromaticity coordinates of the source primaries

`transfer_characteristics` (guint8) –

indicates the opto-electronic transfer characteristic

`matrix_coefficients` (guint8) –

describes the matrix coefficients used in deriving luma and chroma signals

`chroma_loc_info_present_flag` (guint8) –

TRUE specifies that chroma_sample_loc_type_top_field and chroma_sample_loc_type_bottom_field are present, FALSE otherwise

`chroma_sample_loc_type_top_field` (guint8) –

specify the location of chroma for top field chroma_sample_loc_type_bottom_field specify the location of chroma for bottom field

`chroma_sample_loc_type_bottom_field` (guint8) –
No description available
`timing_info_present_flag` (guint8) –

TRUE specifies that num_units_in_tick, time_scale and fixed_frame_rate_flag are present in the bitstream

`num_units_in_tick` (guint32) –

is the number of time units of a clock operating at the frequency time_scale Hz time_scale: is the number of time units that pass in one second

`time_scale` (guint32) –
No description available
`fixed_frame_rate_flag` (guint8) –

TRUE indicates that the temporal distance between the HRD output times of any two consecutive pictures in output order is constrained as specified in the spec, FALSE otherwise.

`nal_hrd_parameters_present_flag` (guint8) –

TRUE if NAL HRD parameters exist in the bitstream

`nal_hrd_parameters` (GstH264HRDParams) –
No description available
`vcl_hrd_parameters_present_flag` (guint8) –

TRUE if VCL HRD parameters exist in the bitstream

`vcl_hrd_parameters` (GstH264HRDParams) –
No description available
`low_delay_hrd_flag` (guint8) –

specifies the HRD operational mode

`pic_struct_present_flag` (guint8) –

TRUE specifies that picture timing SEI messages are present or not

`bitstream_restriction_flag` (guint8) –

TRUE specifies that the following coded video sequence bitstream restriction parameters are present

`motion_vectors_over_pic_boundaries_flag` (guint8) –

FALSE indicates that no sample outside the picture boundaries and no sample at a fractional sample position, TRUE indicates that one or more samples outside picture boundaries may be used in inter prediction

`max_bytes_per_pic_denom` (guint32) –

indicates a number of bytes not exceeded by the sum of the sizes of the VCL NAL units associated with any coded picture in the coded video sequence.

`max_bits_per_mb_denom` (guint32) –

indicates the maximum number of coded bits of macroblock_layer

`log2_max_mv_length_horizontal` (guint32) –

indicate the maximum absolute value of a decoded horizontal motion vector component

`log2_max_mv_length_vertical` (guint32) –

indicate the maximum absolute value of a decoded vertical motion vector component

`num_reorder_frames` (guint32) –

indicates the maximum number of frames, complementary field pairs, or non-paired fields that precede any frame,

`max_dec_frame_buffering` (guint32) –

specifies the required size of the HRD decoded picture buffer in units of frame buffers.

`par_n` (guint) –
No description available
`par_d` (guint) –
No description available

## Enumerations

### GstCtType

    typedef enum
    {
      GST_H264_CT_TYPE_PROGRESSIVE = 0,
      GST_H264_CT_TYPE_INTERLACED = 1,
      GST_H264_CT_TYPE_UNKNOWN = 2,
    } GstCtType;

#### Members

`GST_H264_CT_TYPE_PROGRESSIVE` (0) –
No description available
`GST_H264_CT_TYPE_INTERLACED` (1) –
No description available
`GST_H264_CT_TYPE_UNKNOWN` (2) –
No description available

### GstH264FramePackingType

    typedef enum
    {
      GST_H264_FRAME_PACKING_NONE                           = 6,
      GST_H264_FRAME_PACKING_CHECKERBOARD_INTERLEAVING      = 0,
      GST_H264_FRAME_PACKING_COLUMN_INTERLEAVING            = 1,
      GST_H264_FRAME_PACKING_ROW_INTERLEAVING               = 2,
      GST_H264_FRAME_PACKING_SIDE_BY_SIDE                   = 3,
      GST_H264_FRMAE_PACKING_TOP_BOTTOM                     = 4,

      /**
       * GST_H264_FRAME_PACKING_TOP_BOTTOM:
       *
       * Top-Bottom packing
       *
       * Since: 1.22
       */
      GST_H264_FRAME_PACKING_TOP_BOTTOM                     = 4,
      GST_H264_FRAME_PACKING_TEMPORAL_INTERLEAVING          = 5
    } GstH264FramePackingType;

Frame packing arrangement types.

#### Members

`GST_H264_FRAME_PACKING_NONE` (6) –

A complete 2D frame without any frame packing

`GST_H264_FRAME_PACKING_CHECKERBOARD_INTERLEAVING` (0) –

Checkerboard based interleaving

`GST_H264_FRAME_PACKING_COLUMN_INTERLEAVING` (1) –

Column based interleaving

`GST_H264_FRAME_PACKING_ROW_INTERLEAVING` (2) –

Row based interleaving

`GST_H264_FRAME_PACKING_SIDE_BY_SIDE` (3) –

Side-by-side packing

`GST_H264_FRMAE_PACKING_TOP_BOTTOM` (4) –

Deprecated; use GST_H264_FRAME_PACKING_TOP_BOTTOM instead

`GST_H264_FRAME_PACKING_TOP_BOTTOM` (4) –

Top-Bottom packing

(Since: 1.22)
`GST_H264_FRAME_PACKING_TEMPORAL_INTERLEAVING` (5) –

Temporal interleaving

Since : 1.6

### GstH264Level

    typedef enum
    {
      GST_H264_LEVEL_L1 = 10,
      GST_H264_LEVEL_L1B = 9,
      GST_H264_LEVEL_L1_1 = 11,
      GST_H264_LEVEL_L1_2 = 12,
      GST_H264_LEVEL_L1_3 = 13,
      GST_H264_LEVEL_L2 = 20,
      GST_H264_LEVEL_L2_1 = 21,
      GST_H264_LEVEL_L2_2 = 22,
      GST_H264_LEVEL_L3 = 30,
      GST_H264_LEVEL_L3_1 = 31,
      GST_H264_LEVEL_L3_2 = 32,
      GST_H264_LEVEL_L4 = 40,
      GST_H264_LEVEL_L4_1 = 41,
      GST_H264_LEVEL_L4_2 = 42,
      GST_H264_LEVEL_L5 = 50,
      GST_H264_LEVEL_L5_1 = 51,
      GST_H264_LEVEL_L5_2 = 52,
      GST_H264_LEVEL_L6 = 60,
      GST_H264_LEVEL_L6_1 = 61,
      GST_H264_LEVEL_L6_2 = 62,
    } GstH264Level;

H.264 level

#### Members

`GST_H264_LEVEL_L1` (10) –

Level 1

`GST_H264_LEVEL_L1B` (9) –

Level 1b

`GST_H264_LEVEL_L1_1` (11) –

Level 1.1

`GST_H264_LEVEL_L1_2` (12) –

Level 1.2

`GST_H264_LEVEL_L1_3` (13) –

Level 1.3

`GST_H264_LEVEL_L2` (20) –

Level 2

`GST_H264_LEVEL_L2_1` (21) –

Level 2.1

`GST_H264_LEVEL_L2_2` (22) –

Level 2.2

`GST_H264_LEVEL_L3` (30) –

Level 3

`GST_H264_LEVEL_L3_1` (31) –

Level 3.1

`GST_H264_LEVEL_L3_2` (32) –

Level 3.2

`GST_H264_LEVEL_L4` (40) –

Level 4

`GST_H264_LEVEL_L4_1` (41) –

Level 4.1

`GST_H264_LEVEL_L4_2` (42) –

Level 4.2

`GST_H264_LEVEL_L5` (50) –

Level 5

`GST_H264_LEVEL_L5_1` (51) –

Level 5.1

`GST_H264_LEVEL_L5_2` (52) –

Level 5.2

`GST_H264_LEVEL_L6` (60) –

Level 6

`GST_H264_LEVEL_L6_1` (61) –

Level 6.1

`GST_H264_LEVEL_L6_2` (62) –

Level 6.2

Since : 1.24

### GstH264NalUnitExtensionType

    typedef enum
    {
      GST_H264_NAL_EXTENSION_NONE = 0,
      GST_H264_NAL_EXTENSION_SVC,
      GST_H264_NAL_EXTENSION_MVC,
    } GstH264NalUnitExtensionType;

Indicates the type of H.264 NAL unit extension.

#### Members

`GST_H264_NAL_EXTENSION_NONE` (0) –

No NAL unit header extension is available

`GST_H264_NAL_EXTENSION_SVC` (1) –

NAL unit header extension for SVC (Annex G)

`GST_H264_NAL_EXTENSION_MVC` (2) –

NAL unit header extension for MVC (Annex H)

Since : 1.6

### GstH264NalUnitType

    typedef enum
    {
      GST_H264_NAL_UNKNOWN      = 0,
      GST_H264_NAL_SLICE        = 1,
      GST_H264_NAL_SLICE_DPA    = 2,
      GST_H264_NAL_SLICE_DPB    = 3,
      GST_H264_NAL_SLICE_DPC    = 4,
      GST_H264_NAL_SLICE_IDR    = 5,
      GST_H264_NAL_SEI          = 6,
      GST_H264_NAL_SPS          = 7,
      GST_H264_NAL_PPS          = 8,
      GST_H264_NAL_AU_DELIMITER = 9,
      GST_H264_NAL_SEQ_END      = 10,
      GST_H264_NAL_STREAM_END   = 11,
      GST_H264_NAL_FILLER_DATA  = 12,
      GST_H264_NAL_SPS_EXT      = 13,
      GST_H264_NAL_PREFIX_UNIT  = 14,
      GST_H264_NAL_SUBSET_SPS   = 15,
      GST_H264_NAL_DEPTH_SPS    = 16,

      /**
       * GST_H264_NAL_RSV_1:
       *
       * First reserved parameter
       *
       * Since: 1.24
       */
      GST_H264_NAL_RSV_1        = 17,

      /**
       * GST_H264_NAL_RSV_2:
       *
       * Second reserved parameter
       *
       * Since: 1.24
       */
      GST_H264_NAL_RSV_2        = 18,
      GST_H264_NAL_SLICE_AUX    = 19,
      GST_H264_NAL_SLICE_EXT    = 20,
      GST_H264_NAL_SLICE_DEPTH  = 21
    } GstH264NalUnitType;

Indicates the type of H264 Nal Units

#### Members

`GST_H264_NAL_UNKNOWN` (0) –

Unknown nal type

`GST_H264_NAL_SLICE` (1) –

Slice nal

`GST_H264_NAL_SLICE_DPA` (2) –

DPA slice nal

`GST_H264_NAL_SLICE_DPB` (3) –

DPB slice nal

`GST_H264_NAL_SLICE_DPC` (4) –

DPC slice nal

`GST_H264_NAL_SLICE_IDR` (5) –

DPR slice nal

`GST_H264_NAL_SEI` (6) –

Supplemental enhancement information (SEI) nal unit

`GST_H264_NAL_SPS` (7) –

Sequence parameter set (SPS) nal unit

`GST_H264_NAL_PPS` (8) –

Picture parameter set (PPS) nal unit

`GST_H264_NAL_AU_DELIMITER` (9) –

Access unit (AU) delimiter nal unit

`GST_H264_NAL_SEQ_END` (10) –

End of sequence nal unit

`GST_H264_NAL_STREAM_END` (11) –

End of stream nal unit

`GST_H264_NAL_FILLER_DATA` (12) –

Filler data nal lunit

`GST_H264_NAL_SPS_EXT` (13) –

Sequence parameter set (SPS) extension NAL unit

`GST_H264_NAL_PREFIX_UNIT` (14) –

Prefix NAL unit

`GST_H264_NAL_SUBSET_SPS` (15) –

Subset sequence parameter set (SSPS) NAL unit

`GST_H264_NAL_DEPTH_SPS` (16) –

Depth parameter set (DPS) NAL unit

`GST_H264_NAL_RSV_1` (17) –

First reserved parameter

(Since: 1.24)
`GST_H264_NAL_RSV_2` (18) –

Second reserved parameter

(Since: 1.24)
`GST_H264_NAL_SLICE_AUX` (19) –

Auxiliary coded picture without partitioning NAL unit

`GST_H264_NAL_SLICE_EXT` (20) –

Coded slice extension NAL unit

`GST_H264_NAL_SLICE_DEPTH` (21) –

Coded slice extension for depth or 3D-AVC texture view

### GstH264ParserResult

    typedef enum
    {
      GST_H264_PARSER_OK,
      GST_H264_PARSER_BROKEN_DATA,
      GST_H264_PARSER_BROKEN_LINK,
      GST_H264_PARSER_ERROR,
      GST_H264_PARSER_NO_NAL,
      GST_H264_PARSER_NO_NAL_END
    } GstH264ParserResult;

The result of parsing H264 data.

#### Members

`GST_H264_PARSER_OK` (0) –

The parsing succeeded

`GST_H264_PARSER_BROKEN_DATA` (1) –

The data to parse is broken

`GST_H264_PARSER_BROKEN_LINK` (2) –

The link to structure needed for the parsing couldn't be found

`GST_H264_PARSER_ERROR` (3) –

An error occurred when parsing

`GST_H264_PARSER_NO_NAL` (4) –

No NAL unit found during the parsing

`GST_H264_PARSER_NO_NAL_END` (5) –

Start of the NAL unit found, but not the end. This will be returned if no start/sync marker for the next NAL unit was found. In this case the parser will assume that the end of the data is also the end of the NAL unit. Whether this assumption is correct or not depends on the context, which only the caller can know, which is why a special result value is returned in this case. If the data is NAL-aligned then GST_H264_PARSER_NO_NAL_END can be treated just like GST_H264_PARSER_OK. If the data is not guaranteed to be NAL-aligned, then the caller probably wants to collect more data until there's another sync marker or the end of the stream has been reached.

### GstH264Profile

    typedef enum {
      GST_H264_PROFILE_BASELINE             = 66,
      GST_H264_PROFILE_MAIN                 = 77,
      GST_H264_PROFILE_EXTENDED             = 88,
      GST_H264_PROFILE_HIGH                 = 100,
      GST_H264_PROFILE_HIGH10               = 110,
      GST_H264_PROFILE_HIGH_422             = 122,
      GST_H264_PROFILE_HIGH_444             = 244,
      GST_H264_PROFILE_MULTIVIEW_HIGH       = 118,
      GST_H264_PROFILE_STEREO_HIGH          = 128,
      GST_H264_PROFILE_SCALABLE_BASELINE    = 83,
      GST_H264_PROFILE_SCALABLE_HIGH        = 86,
      /**
       * GST_H264_PROFILE_INVALID:
       *
       * Invalid H264 profile
       *
       * Since: 1.24
       */
      GST_H264_PROFILE_INVALID              = -1
    } GstH264Profile;

H.264 Profiles.

#### Members

`GST_H264_PROFILE_BASELINE` (66) –

Baseline profile (A.2.1)

`GST_H264_PROFILE_MAIN` (77) –

Main profile (A.2.2)

`GST_H264_PROFILE_EXTENDED` (88) –

Extended profile (A.2.3)

`GST_H264_PROFILE_HIGH` (100) –

High profile (A.2.4), or Progressive High profile (A.2.4.1), or Constrained High profile (A.2.4.2) depending on constraint_set4_flag and constraint_set5_flag

`GST_H264_PROFILE_HIGH10` (110) –

High 10 profile (A.2.5) or High 10 Intra profile (A.2.8), or Progressive High 10 profile (A.2.5.1) depending on constraint_set3_flag and constraint_set4_flag

`GST_H264_PROFILE_HIGH_422` (122) –

High 4:2:2 profile (A.2.6) or High 4:2:2 Intra profile (A.2.9), depending on constraint_set3_flag

`GST_H264_PROFILE_HIGH_444` (244) –

High 4:4:4 Predictive profile (A.2.7) or High 4:4:4 Intra profile (A.2.10), depending on the value of constraint_set3_flag

`GST_H264_PROFILE_MULTIVIEW_HIGH` (118) –

Multiview High profile (H.10.1.1)

`GST_H264_PROFILE_STEREO_HIGH` (128) –

Stereo High profile (H.10.1.2)

`GST_H264_PROFILE_SCALABLE_BASELINE` (83) –

Scalable Baseline profile (G.10.1.1)

`GST_H264_PROFILE_SCALABLE_HIGH` (86) –

Scalable High profile (G.10.1.2) or Scalable High Intra profile (G.10.1.3), depending on the value of constraint_set3_flag

`GST_H264_PROFILE_INVALID` (-1) –

Invalid H264 profile

(Since: 1.24)

Since : 1.2

### GstH264SEIPayloadType

    typedef enum
    {
      GST_H264_SEI_BUF_PERIOD = 0,
      GST_H264_SEI_PIC_TIMING = 1,
      GST_H264_SEI_REGISTERED_USER_DATA = 4,
      GST_H264_SEI_USER_DATA_UNREGISTERED = 5,
      GST_H264_SEI_RECOVERY_POINT = 6,
      GST_H264_SEI_STEREO_VIDEO_INFO = 21,
      GST_H264_SEI_FRAME_PACKING = 45,
      GST_H264_SEI_MASTERING_DISPLAY_COLOUR_VOLUME = 137,
      GST_H264_SEI_CONTENT_LIGHT_LEVEL = 144,
          /* and more...  */

      /* Unhandled SEI type */
      GST_H264_SEI_UNHANDLED_PAYLOAD = -1
    } GstH264SEIPayloadType;

The type of SEI message.

#### Members

`GST_H264_SEI_BUF_PERIOD` (0) –

Buffering Period SEI Message

`GST_H264_SEI_PIC_TIMING` (1) –

Picture Timing SEI Message

`GST_H264_SEI_REGISTERED_USER_DATA` (4) –

Registered user data (D.2.5)

`GST_H264_SEI_USER_DATA_UNREGISTERED` (5) –

User Data Unregistered (D.2.6)

(Since: 1.22)
`GST_H264_SEI_RECOVERY_POINT` (6) –

Recovery Point SEI Message (D.2.7)

`GST_H264_SEI_STEREO_VIDEO_INFO` (21) –

stereo video info SEI message (Since: 1.6)

`GST_H264_SEI_FRAME_PACKING` (45) –

Frame Packing Arrangement (FPA) message that contains the 3D arrangement for stereoscopic 3D video (Since: 1.6)

`GST_H264_SEI_MASTERING_DISPLAY_COLOUR_VOLUME` (137) –

Mastering display colour volume information SEI message (D.2.29) (Since: 1.18)

`GST_H264_SEI_CONTENT_LIGHT_LEVEL` (144) –

Content light level information SEI message (D.2.31) (Since: 1.18)

`GST_H264_SEI_UNHANDLED_PAYLOAD` (-1) –

Unhandled SEI message. This may or may not be defined by spec (Since 1.18) ...

### GstH264SEIPicStructType

    typedef enum
    {
      GST_H264_SEI_PIC_STRUCT_FRAME             = 0,
      GST_H264_SEI_PIC_STRUCT_TOP_FIELD         = 1,
      GST_H264_SEI_PIC_STRUCT_BOTTOM_FIELD      = 2,
      GST_H264_SEI_PIC_STRUCT_TOP_BOTTOM        = 3,
      GST_H264_SEI_PIC_STRUCT_BOTTOM_TOP        = 4,
      GST_H264_SEI_PIC_STRUCT_TOP_BOTTOM_TOP    = 5,
      GST_H264_SEI_PIC_STRUCT_BOTTOM_TOP_BOTTOM = 6,
      GST_H264_SEI_PIC_STRUCT_FRAME_DOUBLING    = 7,
      GST_H264_SEI_PIC_STRUCT_FRAME_TRIPLING    = 8
    } GstH264SEIPicStructType;

SEI pic_struct type

#### Members

`GST_H264_SEI_PIC_STRUCT_FRAME` (0) –

Picture is a frame

`GST_H264_SEI_PIC_STRUCT_TOP_FIELD` (1) –

Top field of frame

`GST_H264_SEI_PIC_STRUCT_BOTTOM_FIELD` (2) –

Bottom field of frame

`GST_H264_SEI_PIC_STRUCT_TOP_BOTTOM` (3) –

Top bottom field of frame

`GST_H264_SEI_PIC_STRUCT_BOTTOM_TOP` (4) –

bottom top field of frame

`GST_H264_SEI_PIC_STRUCT_TOP_BOTTOM_TOP` (5) –

top bottom top field of frame

`GST_H264_SEI_PIC_STRUCT_BOTTOM_TOP_BOTTOM` (6) –

bottom top bottom field of frame

`GST_H264_SEI_PIC_STRUCT_FRAME_DOUBLING` (7) –

indicates that the frame should be displayed two times consecutively

`GST_H264_SEI_PIC_STRUCT_FRAME_TRIPLING` (8) –

indicates that the frame should be displayed three times consecutively

### GstH264SliceType

    typedef enum
    {
      GST_H264_P_SLICE    = 0,
      GST_H264_B_SLICE    = 1,
      GST_H264_I_SLICE    = 2,
      GST_H264_SP_SLICE   = 3,
      GST_H264_SI_SLICE   = 4,
      GST_H264_S_P_SLICE  = 5,
      GST_H264_S_B_SLICE  = 6,
      GST_H264_S_I_SLICE  = 7,
      GST_H264_S_SP_SLICE = 8,
      GST_H264_S_SI_SLICE = 9
    } GstH264SliceType;

Type of Picture slice

#### Members

`GST_H264_P_SLICE` (0) –
No description available
`GST_H264_B_SLICE` (1) –
No description available
`GST_H264_I_SLICE` (2) –
No description available
`GST_H264_SP_SLICE` (3) –
No description available
`GST_H264_SI_SLICE` (4) –
No description available
`GST_H264_S_P_SLICE` (5) –
No description available
`GST_H264_S_B_SLICE` (6) –
No description available
`GST_H264_S_I_SLICE` (7) –
No description available
`GST_H264_S_SP_SLICE` (8) –
No description available
`GST_H264_S_SI_SLICE` (9) –
No description available

The results of the search are